#! /usr/local/bin/perl

######################################
#BooBBS v2.40 / this program is free.#
#(C) BooBooClub 1998-2006            #
######################################


#set data
$max = '30';
$cgi = './bbbs.cgi';
$dat = './bdata.dat';
$admin = './badmin.cgi';
$address = 'Admin@mail.address';
$bbstitle = 'BooBBS';
$head = '<font size="5">BooBBS</font>';
$linkname = 'Back';
$linkurl = './linkurl';
$back = 'bgcolor="#ffffff"';
$linkc= 'text="#000000" link="#0000ff" vlink="880088"';
$nomail = '#888888';
$fonts = '2';
$type = 't';
$autolink = 'on';
$faq = 'on';



#read lib
require 'jcode.pl';



#lock check
$lockfile = './lock/lockfile';
$retry = 1;
until(symlink("$dat", "$lockfile")){
	if(++$retry >= 30){
		unlink("$lockfile"); 
		exit 0;
	}
	sleep(1);
}


#time
$ENV{'TZ'}='JST-9';
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year = ($year + 1900);
$mon++;
if ($sec < 10) {	$sec = "0$sec";}
if ($min < 10) {	$min = "0$min";}
if ($hour < 10){	$hour = "0$hour";}
if ($mon < 10) {	$mon = "0$mon";}
if ($mday < 10){	$mday = "0$mday";}
$time = "$year/$mon/$mday $hour:$min:$sec";


#read
if($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else{
	$buffer = $ENV{'QUERY_STRING'};
}

@pairs = split(/&/,$buffer);
foreach $pair(@pairs){
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/\cM\n//g;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\,//g;
	$value =~ s/</&lt;/ig;
	$value =~ s/>/&gt;/ig;
	$value =~ s/\r\n|[\r\n]/<br>/ig;
	&jcode'convert(*value,'sjis');
	$FORM{$name} = $value;
}



#branch
if($FORM{'submit'} ne ''){
	&html;
}
else{
	&check;
	&write;
	&html;
}



sub check{
	if($FORM{'name'} eq ''||$FORM{'title'} eq ''||$FORM{'txt'} eq ''){
		&error;
	}
}



sub write{ 
	open (DAT,"$dat");
	@bbsdats = <DAT>;
	close (DAT);

	if($autolink eq 'on'){
		$FORM{'txt'} =~ s/(http:[\w\.\/\~\+\-\?%=&^]+)/<a href="$1">$1<\/a>/g;
		$FORM{'txt'} =~ s/([\w\.\-]+@[\w\.\-]+)/<a href="mailto:$1">$1<\/a>/g;
	}
	elsif($autolink eq 'onw'){
		$FORM{'txt'} =~ s/(http:[\w\.\/\~\+\-\?%=&^]+)/<a href="$1" target="_blank">$1<\/a>/g;
		$FORM{'txt'} =~ s/([\w\.\-]+@[\w\.\-]+)/<a href="mailto:$1">$1<\/a>/g;
	}

	$wrt = "$FORM{'name'}\,$FORM{'mail'}\,$FORM{'title'}\,$FORM{'txt'}\,$time\n";

	unshift(@bbsdats,$wrt);
	$hml = @bbsdats;

	if($hml > $max){
		$max--;
		@ndat = @bbsdats[0..$max];
	}
	else{
		@ndat = @bbsdats;
	}

	#write new dat
	open (DAT,">$dat");
	print DAT @ndat;
	close (DAT);
}	



sub html{
	#get dat
	open (DAT,"$dat");
	@bbsdats = <DAT>;
	close (DAT);

	#html
	print "Content-type: text/html\n\n";
	print "<html><head><title>$bbstitle</title></head>\n";
	print "<body $back $linkc>\n";
	print "<center>\n";
	print "$head\n";
	print "<hr>\n";

	if($type eq "b"){
		print "<a href=\"\#WRITE\">[]</a>\n";
	}
	if($faq eq 'on'){
		print "@<a href=\"bfaq.html\">[e`p]</a>\n";
	}

	print "@<a href=\"mailto:$address\">[Mail to Admin]</a>\n";
	print "@<a href=\"$admin\">[For Admin]</a>\n";
	print "@<a href=\"$linkurl\">[$linkname]</a>\n";
	print "</center>\n";

	if($type eq "b"){
		&view;
		&form;
		print "<hr>\n";
	}
	else{
		print "<hr>\n";
		&form;
		&view;
	}

	print "<div align=\"right\">Produced by <a href\=\"http:\/\/www.booboo.ne.jp/\">BooBooClub</a></div></font><br>\n";
	print "</body></html>\n";
	unlink("$lockfile");
	exit 0;
}



sub view{
	print "<blockquote>\n\n";
	foreach $bbsdat(@bbsdats) {
		($name,$mail,$title,$txt,$time) = split(/,/,$bbsdat);

		print "<hr><b>$title</b><br>";

		if($mail ne ""){
			print "<a href=\"mailto:$mail\">$name</a>@";
		}
		else{
			print "<font color=\"$nomail\">$name</font>@";
		}

		print "<i>$time</i><br>";
		print "<br><font size=$fonts>$txt</font>\n\n";
	}
	print "</blockquote>\n";
	print "<hr>\n";
}



sub form{
	print "<blockquote>\n";
	print "<form action=\"$cgi\" method=\"POST\">\n";
	print "<a name=\"WRITE\">O@F</a>\n";
	print "<input size=\"30\" name=\"name\">\n";
	print "<br>\n";
	print "E-mailF\n";
	print "<input size=\"30\" name=\"mail\">\n";
	print "<BR>\n";
	print "@F\n";
	print "<input size=\"50\" name=\"title\">\n";
	print "<BR>\n";
	print "e@F\n";
	print "<textarea rows=\"3\" cols=\"65\" name=\"txt\"></textarea>\n";
	print "<p>\n";
	print "@@@@@<input type=\"submit\" name=\"submit\" value=\"\">";
	print "@<input type=\"reset\" value=\"Zbg\">\n";
	print "<br>\n";
	print "</form>\n";
	print "</blockquote>\n";
}



sub error{
	print "Content-type: text/html\n\n";
	print "<html><head><title>$bbstitle</title></head>\n";
	print "<body $back $linkc>\n";
	print "<br><h2>Error</h2><br><br>\n";
	print "<font size=4>L܂Bē͂ĂB</font>\n";
	print "<br></body></html>\n";
	unlink("$lockfile");
	exit 0;
}

